unit LptFm;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QTypes, QExtCtrls, QStdCtrls, QComCtrls, HW_32;

type

  TLptForm = class(TForm)
    G_Read: TGroupBox;
    Label38: TLabel;
    Label39: TLabel;
    RPin1: TCheckBox;
    RPin2: TCheckBox;
    RPin3: TCheckBox;
    RPin4: TCheckBox;
    RPin5: TCheckBox;
    RPin6: TCheckBox;
    Rpin7: TCheckBox;
    RPin8: TCheckBox;
    RPin9: TCheckBox;
    RPin10: TCheckBox;
    RPin11: TCheckBox;
    RPin12: TCheckBox;
    RPin13: TCheckBox;
    RPin14: TCheckBox;
    RPin15: TCheckBox;
    RPin16: TCheckBox;
    RPin17: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    CheckBox20: TCheckBox;
    CheckBox21: TCheckBox;
    CheckBox22: TCheckBox;
    CheckBox23: TCheckBox;
    GroupBox3: TGroupBox;
    Label40: TLabel;
    Label41: TLabel;
    WPin1: TCheckBox;
    WPin2: TCheckBox;
    WPin3: TCheckBox;
    WPin4: TCheckBox;
    WPin5: TCheckBox;
    WPin6: TCheckBox;
    WPin7: TCheckBox;
    WPin8: TCheckBox;
    WPin9: TCheckBox;
    WPin14: TCheckBox;
    WPin15: TCheckBox;
    WPin17: TCheckBox;
    WPin10: TCheckBox;
    WPin11: TCheckBox;
    WPin12: TCheckBox;
    WPin13: TCheckBox;
    WPin16: TCheckBox;
    CheckBox24: TCheckBox;
    CheckBox25: TCheckBox;
    CheckBox26: TCheckBox;
    CheckBox27: TCheckBox;
    CheckBox28: TCheckBox;
    CheckBox29: TCheckBox;
    CheckBox30: TCheckBox;
    CheckBox31: TCheckBox;
    GroupBox5: TGroupBox;
    C_BUSY: TCheckBox;
    C_PE: TCheckBox;
    C_ERROR: TCheckBox;
    C_ACKWL: TCheckBox;
    C_SLCT: TCheckBox;
    GroupBox7: TGroupBox;
    Label42: TLabel;
    L_LPTs: TLabel;
    Label43: TLabel;
    Label47: TLabel;
    L_Base: TLabel;
    SpinLPT: TSpinEdit;
    GroupBox8: TGroupBox;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    L_LptGen: TLabel;
    L_LptHan: TLabel;
    L_LptPer: TLabel;
    R_LptIrq7: TRadioButton;
    R_LptIrq5: TRadioButton;
    C_ForceLptIrq: TCheckBox;
    C_UnmaskLptIrq: TCheckBox;
    C_LptTimer: TCheckBox;
    C_Hard: TCheckBox;
    C_ReadMode: TCheckBox;
    Timer1: TTimer;
    LptTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure C_ForceLptIrqClick(Sender: TObject);
    procedure C_UnmaskLptIrqClick(Sender: TObject);
    procedure C_LptTimerClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure LptTimerTimer(Sender: TObject);
    procedure SpinLPTChanged(Sender: TObject; NewValue: Integer);
    procedure C_ReadModeClick(Sender: TObject);
    procedure C_HardClick(Sender: TObject);
    procedure WPin1Click(Sender: TObject);
    procedure R_LptIrq7Click(Sender: TObject);
    procedure R_LptIrq5Click(Sender: TObject);
    procedure HW32HwInterrupt(IrqNumber: Word);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ShowButtons;
  end;

var
  LptForm: TLptForm;


implementation

uses MainFm;

var
  HW32 : TVicHW32;
  w,h  : Word;
  CurrIRQNumber  : Word;
  IRQHandled     : Longint;
  Period         : Double;
  OldTime, CurrTime : TDateTime;
  CPinRead, CPinWrite : array[0..25] of TCheckBox;

{$R *.xfm}

procedure TLptForm.HW32HwInterrupt(IrqNumber: Word);
var
  a,b : double;
begin
  if IRQHandled = 0 then   OldTime := Now;
  Inc(IRQHandled);
  CurrTime:= Now;
  a:=IRQHandled;
  b:=Abs(DateTimeToTimeStamp(CurrTime).Time - DateTimeToTimeStamp(OldTime).Time);
  if IRQHandled>1 then period:= b/(a-1);
end;

procedure TLptForm.ShowButtons;
begin

  if HW32 = NIL then Exit;
  C_UnmaskLptIrq.Enabled := (not C_LptTimer.Checked) and C_ForceLptIrq.Checked;
  C_LptTimer.Enabled := C_UnmaskLptIrq.Checked and C_ForceLptIrq.Checked;
  SpinLPT.Enabled:=Active;
  SpinLPT.Max:=HW32.LPTNumPorts;
  SpinLPT.Value := HW32.LPTNumber;
  L_LPTs.caption:=IntToStr(HW32.LPTNumPorts);
  L_BASE.caption:=IntToHex(HW32.LPTBasePort,3)+'h';

end;


procedure TLptForm.FormCreate(Sender: TObject);
begin

  HW32 := MainForm.HW32;
  HW32.OnHwInterrupt := HW32HwInterrupt;
  CurrIrqNumber := 7;
  w := Width;
  h := Height;

  CPinRead[ 1]:=RPin1;    CPinWrite[ 1]:=WPin1;
  CPinRead[ 2]:=RPin2;    CPinWrite[ 2]:=WPin2;
  CPinRead[ 3]:=RPin3;    CPinWrite[ 3]:=WPin3;
  CPinRead[ 4]:=RPin4;    CPinWrite[ 4]:=WPin4;
  CPinRead[ 5]:=RPin5;    CPinWrite[ 5]:=WPin5;
  CPinRead[ 6]:=RPin6;    CPinWrite[ 6]:=WPin6;
  CPinRead[ 7]:=RPin7;    CPinWrite[ 7]:=WPin7;
  CPinRead[ 8]:=RPin8;    CPinWrite[ 8]:=WPin8;
  CPinRead[ 9]:=RPin9;    CPinWrite[ 9]:=WPin9;
  CPinRead[10]:=RPin10;   CPinWrite[10]:=WPin10; WPin10.Enabled:=FALSE;
  CPinRead[11]:=RPin11;   CPinWrite[11]:=WPin11; WPin11.Enabled:=FALSE;
  CPinRead[12]:=RPin12;   CPinWrite[12]:=WPin12; WPin12.Enabled:=FALSE;
  CPinRead[13]:=RPin13;   CPinWrite[13]:=WPin13; WPin13.Enabled:=FALSE;
  CPinRead[14]:=RPin14;   CPinWrite[14]:=WPin14;
  CPinRead[15]:=RPin15;   CPinWrite[15]:=WPin15; WPin15.Enabled:=FALSE;
  CPinRead[16]:=RPin16;   CPinWrite[16]:=WPin16;
  CPinRead[17]:=RPin17;   CPinWrite[17]:=WPin17;

  ShowButtons;

end;

procedure TLptForm.C_ForceLptIrqClick(Sender: TObject);
begin
  HW32.LPTIRQEnabled := C_ForceLptIrq.Checked;
  ShowButtons;
end;

procedure TLptForm.C_UnmaskLptIrqClick(Sender: TObject);
begin
if C_UnmaskLptIrq.Checked then
  begin
    IRQHandled  := 0;
    HW32.UnmaskInterrupt(CurrIrqNumber);
    OldTime:=Now;
  end
  else begin
         HW32.MaskInterrupt(CurrIrqNumber);
       end;
  ShowButtons;
end;

procedure TLptForm.C_LptTimerClick(Sender: TObject);
begin
  if C_LptTimer.Checked then IrqHandled := 0;
  LptTimer.Enabled := C_LptTimer.Checked;
  ShowButtons;
end;

procedure TLptForm.Timer1Timer(Sender: TObject);
var nPin : Word;
    s : String;
begin

  if HW32 <> nil then
  begin
  
    L_LptGen.Caption := IntToStr(HW32.InterruptCounter(CurrIrqNumber));
    L_LptHan.Caption := IntToStr(IRQHandled);
    Str(period:10:6,s);
    L_LptPer.Caption:=s;

    for nPin:=1 to 17 do
      CPinRead[nPin].Checked:=HW32.Pin[nPin];

    C_ACKWL.Checked := HW32.LPTAckwl;
    C_Busy.Checked  := HW32.LPTBusy;
    C_ERROR.Checked := HW32.LPTError;
    C_PE.Checked    := HW32.LPTPaperEnd;
    C_SLCT.Checked  := HW32.LPTSlct;

  end;

end;

procedure TLptForm.LptTimerTimer(Sender: TObject);
var nPort : Word;
begin

      // for this test you need create an electrical connection between
      // pin10(Ack line) to any Pin 2..9 by chunk of the wire. In this case,
      // when we will write ff/00 sequential code to the data register then
      // it will provoke an interruptions from LPT.

      nPort := HW32.LPTBasePort;

      if C_ReadMode.Checked then
        HW32.LPTReadMode := false; // switch to "Write Mode" to generate an interruption

      HW32.Port[nPort] := $00;  // write 00 to lpt base port
      HW32.Port[nPort] := $ff;  // write ff to lpt base port

      if C_ReadMode.Checked then
        HW32.LPTReadMode := true;  // back to current mode
end;

procedure TLptForm.SpinLPTChanged(Sender: TObject; NewValue: Integer);
begin
  if HW32<> NIL then
    HW32.LPTNumber := NewValue;
  ShowButtons;
end;

procedure TLptForm.C_ReadModeClick(Sender: TObject);
begin
    if HW32.ActiveHW then
      HW32.LPTReadMode :=  C_ReadMode.Checked
    else
      C_ReadMode.Checked := FALSE;
end;

procedure TLptForm.C_HardClick(Sender: TObject);
begin
  HW32.HardAccess := C_Hard.Checked;
  C_Hard.Checked  := HW32.HardAccess;
end;

procedure TLptForm.WPin1Click(Sender: TObject);
var nPin : Byte;
begin
  for nPin:=1 to 17 do
     HW32.Pin[nPin] := CPinWrite[nPin].Checked;
end;

procedure TLptForm.R_LptIrq7Click(Sender: TObject);
begin
  CurrIrqNumber := 7;
end;

procedure TLptForm.R_LptIrq5Click(Sender: TObject);
begin
  CurrIrqNumber := 5;
end;

procedure TLptForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  HW32 := NIL;
  Action := caNone;
end;

initialization
  HW32 := NIL;
end.
