unit MemFm;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls,
  HW_32;

type
  TMemForm = class(TForm)
    Label5: TLabel;
    L_Mem: TListBox;
    B_ReadMemory: TButton;
    E_Addr: TEdit;
    Label1: TLabel;
    procedure B_ReadMemoryClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MemForm: TMemForm;

implementation

uses MainFm;

{$R *.xfm}

var
  HW32 : TVicHW32;
  w,h  : Word;

procedure TMemForm.B_ReadMemoryClick(Sender: TObject);
type TByteArray    = array[0..255] of Byte;
var CurrAddr,i,j   : Longword;
    s,s1           :  String;
    b              : Byte;
    ch             : Char;
    Ofs            : Word;
    PhysAddr       : Longword;
begin

  if E_Addr.Text <> '' then
    PhysAddr:=StrToInt('$'+E_Addr.text)
  else
    PhysAddr := 0;
  E_Addr.Text:=IntToHex(PhysAddr,8);
  CurrAddr := PhysAddr;

  if HW32.ActiveHW then
  begin

    Ofs:=0;
    L_Mem.Clear;
    for i:=1 to 16 do
    begin
      s:=IntToHex(CurrAddr,8)+' ';
      s1 := '';
      for j:=1 to 16 do
      begin
        b:=HW32.Mem[PhysAddr,ofs];
        s:=s+IntToHex(b,2);
        if b>=$20 then ch:=Char(b) else ch:='.';
        s1:=s1+ch;
        Inc(Ofs);
      end;
      s:=s+' '+s1;
      L_Mem.Items.Add(s);
      CurrAddr:=CurrAddr+16;
    end;

  end;

end;

procedure TMemForm.FormCreate(Sender: TObject);
begin
  HW32 := MainForm.HW32;
  w := Width;
  h := Height;
end;

procedure TMemForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caNone;
end;

procedure TMemForm.FormResize(Sender: TObject);
begin
  Width := w;
  Height := h;
  MainForm.LinkForms(Sender);
end;

end.
